﻿using Microsoft.SqlServer.ReportingServices2010;
using PowerED.Models;
using Syncfusion.EJ.ReportViewer;
using Syncfusion.JavaScript.Models.ReportViewer;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Http;
using System.Web.Mvc;
using System.Web.SessionState;

namespace PowerED.Controllers
{
   
    public class ReportAPIController : ApiController, IReportController
    {
        DataSet ds = new DataSet();
        DataTable dt = new DataTable();
        SummaryViewModel _summary;
        HospitalModel _hospital;
        List<KeyPerformanceMetricModel> _kpm;
        List<BaselinePlotModel> _baselinePlots;
        List<MetricDefinitionModel> _definitions;
        GoalModel _goals;
        ReportDateModel _dates;

        public object PostReportAction(Dictionary<string, object> jsonResult)
        {
            return ReportHelper.ProcessReport(jsonResult, this);
        }
        [System.Web.Http.ActionName("GetResource")]
        [System.Web.Http.AcceptVerbs("GET")]
        public object GetResource(string key, string resourcetype, bool isPrint)
        {
            return ReportHelper.GetResource(key, resourcetype, isPrint);
        }
        public void OnInitReportOptions(ReportViewerOptions reportOptions)
        {
            var reportName = HttpContext.Current.Session["ReportName"].ToString();
            if (reportName == "SummaryView")
            {
                reportOptions.ReportModel.ReportServerCredential = new System.Net.NetworkCredential(ConfigurationManager.AppSettings["ReportServerUsername"].ToString(), ConfigurationManager.AppSettings["ReportServerPassword"].ToString(), ConfigurationManager.AppSettings["ReportServerDomain"].ToString());
                reportOptions.ReportModel.ReportPath = ConfigurationManager.AppSettings["ReportsFolder"] + "/" + ConfigurationManager.AppSettings["SummaryViewReportName"];

                List<Syncfusion.Reports.EJ.ReportParameter> parameters = new List<Syncfusion.Reports.EJ.ReportParameter>();
                parameters.Add(new Syncfusion.Reports.EJ.ReportParameter() { Name = "HospitalID", Labels = new List<string>() { "HospitalID" }, Values = new List<string>() { HttpContext.Current.Session["SiteId"].ToString() } });
                parameters.Add(new Syncfusion.Reports.EJ.ReportParameter() { Name = "StartDate", Labels = new List<string>() { "StartDate" }, Values = new List<string>() { HttpContext.Current.Session["ReportStartDate"].ToString() } });
                parameters.Add(new Syncfusion.Reports.EJ.ReportParameter() { Name = "EndDate", Labels = new List<string>() { "EndDate" }, Values = new List<string>() { HttpContext.Current.Session["ReportEndDate"].ToString() } });
                parameters.Add(new Syncfusion.Reports.EJ.ReportParameter() { Name = "Demo", Labels = new List<string>() { "Demo" }, Values = new List<string>() { "false" } });
                reportOptions.ReportModel.Parameters = parameters;
            }
        }
        public void OnReportLoaded(ReportViewerOptions reportOption)
        {
        }

        public void ConvertXMLtoDataSet()
        {
            string strFileName = string.Empty;
            try
            {
                strFileName = System.Web.Hosting.HostingEnvironment.MapPath("~/App_Data/Employee.xml");
                ds.ReadXml(strFileName);
                dt = ds.Tables[0];
            }
            catch (Exception Ex)
            {
                throw Ex;
            }
        }
    }
}